;/*****************************************************************************/
;/* startup_sh3xf2xx_keil.s: Startup file for Sinowealth SH32F2 device series */
;/*****************************************************************************/
;/* <<< Use Configuration Wizard in Context Menu >>>                          */ 
;/*****************************************************************************/
;/* This file is part of the uVision/ARM development tools.                   */
;/* Copyright (c) 2005-2007 Keil Software. All rights reserved.               */
;/* This software may only be used under the terms of a valid, current,       */
;/* end user licence from KEIL for a compatible version of KEIL software      */
;/* development tools. Nothing else gives you the right to use this software. */
;/*****************************************************************************/
; *
; * SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S 
; * MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
; * THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
; * SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
; * WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
; * THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
; * CONNECTION WITH THEIR PRODUCTS.
; *
; * COPYRIGHT 2017 Sinowealth
; *
; ******************************************************************************
; */

;<e>Run Application in User Mode
USER_MODE_EN      EQU  0
;</e>

;// <h> Stack Configuration
;   <o0>System Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
;   <o1>User Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
;// </h> 
SystemStack_Size  EQU     0x00000400
UserStack_Size    EQU     0x00000000

		  AREA    STACK, NOINIT, READWRITE, ALIGN=3
__stack_limit		  
System_Stack_Mem  SPACE   SystemStack_Size
system_stack_top
__user_stack_limit
User_Stack_Mem    SPACE   UserStack_Size
usr_stack_top
__initial_sp

;// <h> Heap Configuration
;//   <o>  Heap Size (in Bytes) <0x0-0xFFFFFFFF>
;// </h>
Heap_Size        EQU     0x00000200

;/*****************************************************************************/
;/*-------- <<< end of configuration section >>> -----------------------------*/
;/*****************************************************************************/

                 AREA    HEAP, NOINIT, READWRITE, ALIGN=3
__heap_base
Heap_Mem         SPACE   Heap_Size
__heap_limit

                PRESERVE8
                THUMB
; Vector Table Mapped to Address 0 at Reset
                         AREA     RESET, DATA, READONLY
                         EXPORT   __Vectors
                         EXPORT   __Vectors_End
                         EXPORT   __Vectors_Size
__Vectors
                         DCD      system_stack_top     ; -16 (000H) Top of Stack
                         DCD      Reset_Handler        ; -15 (004H) Reset Handler
                         DCD      NMI_Handler          ; -14 (008H) Non Maskable Interrupt
                         DCD      HardFault_Handler    ; -13 (00CH) Hard Fault Interrupt
                         DCD      MemManage_Handler    ; -12 (010H) ARM STAR Memory Management Interrupt
                         DCD      BusFault_Handler     ; -11 (014H) ARM STAR Bus Fault Interrupt
                         DCD      UsageFault_Handler   ; -10 (018H) ARM STAR Usage Fault Interrupt
                         DCD      Default_Handler      ;  -9 (01CH) Reserved
                         DCD      Default_Handler      ;  -8 (020H) Reserved
                         DCD      Default_Handler      ;  -7 (024H) Reserved
                         DCD      Default_Handler      ;  -6 (028H) Reserved
                         DCD      SVC_Handler          ;  -5 (02CH) ARM STAR SV Call Interrupt
                         DCD      DebugMon_Handler     ;  -4 (030H) ARM STAR Debug Monitor Interrupt
                         DCD      Default_Handler      ;  -3 (034H) Reserved
                         DCD      PendSV_Handler       ;  -2 (038H) ARM STAR Pend SV Interrupt
                         DCD      SysTick_Handler      ;  -1 (03CH) ARM STAR System Tick Interrupt
                         DCD      WWDT_Handler         ;   0 (040H) Window WatchDog Interrupt
                         DCD      BOD_Handler          ;   1 (044H) PVD through EXTI Line detection Interrupt
                         DCD      RCC_Handler          ;   2 (048H) RCC global Interrupt
                         DCD      EXTI0_Handler        ;   3 (04CH) EXTI Line0 Interrupt
                         DCD      EXTI1_Handler        ;   4 (050H) EXTI Line1 Interrupt
                         DCD      EXTI2_Handler        ;   5 (054H) EXTI Line2 Interrupt
                         DCD      EXTI3_Handler        ;   6 (058H) EXTI Line3 Interrupt
                         DCD      EXTI7_4_Handler      ;   7 (05CH) EXTI Line4~7 Interrupt
                         DCD      DMA_CH0_Handler      ;   8 (060H) DMA Channe0 Interrupt
                         DCD      DMA_CH1_Handler      ;   9 (064H) DMA Channe1 Interrupt
                         DCD      DMA_CH2_Handler      ;  10 (068H) DMA Channe2 Interrupt
                         DCD      DMA_CH3_Handler      ;  11 (06CH) DMA Channe3 Interrupt
                         DCD      DMA_CH4_Handler      ;  12 (070H) DMA Channe4 Interrupt
                         DCD      DMA_CH5_7_Handler    ;  13 (074H) DMA Channe5~7 Interrupt
                         DCD      MCM0_FLT_Handler     ;  14 (078H) MCM FAULT Interrupt
                         DCD      MCM1_FLT_Handler     ;  15 (07CH) MCM FAULT Interrupt
                         DCD      MCM0_PWM_Handler     ;  16 (080H) MCM PWM Interrupt
                         DCD      MCM1_PWM_Handler     ;  17 (084H) MCM PWM Interrupt
                         DCD      ADC0_Handler         ;  18 (088H) ADC0 Interrupt
                         DCD      ADC1_Handler         ;  19 (08CH) ADC1 Interrupt
                         DCD      ADC2_Handler         ;  20 (090H) ADC2 Interrupt
                         DCD      PCA0_FLT_Handler     ;  21 (094H) PCA0 Fault Interrupt
                         DCD      PCA1_FLT_Handler     ;  22 (098H) PCA1 Fault Interrupt
                         DCD      PCA2_FLT_Handler     ;  23 (09CH) PCA2 Fault Interrupt
                         DCD      PCA3_FLT_Handler     ;  24 (0A0H) PCA3 Fault Interrupt
                         DCD      PCA0_Handler         ;  25 (0A4H) PCA0 Interrupt
                         DCD      PCA1_Handler         ;  26 (0A8H) PCA1 Interrupt
                         DCD      PCA2_Handler         ;  27 (0ACH) PCA2 Interrupt
                         DCD      PCA3_Handler         ;  28 (0B0H) PCA3 Interrupt
                         DCD      CMP0_Handler         ;  29 (0B4H) CMP0 Interrupt
                         DCD      CMP1_Handler         ;  30 (0B8H) CMP1 Interrupt
                         DCD      CMP2_Handler         ;  31 (0BCH) CMP2 Interrupt
                         DCD      QEI0_Handler         ;  32 (0C0H) QEI Interrupt
                         DCD      QEI1_Handler         ;  33 (0C4H) QEI Interrupt
                         DCD      CAN0_Handler         ;  34 (0C8H) CAN0 Interrupt
                         DCD      TWI0_Handler         ;  35 (0CCH) TWI0 Interrupt
                         DCD      SPI0_Handler         ;  36 (0D0H) SPI0 Interrupt
                         DCD      SPI1_Handler         ;  37 (0D4H) SPI1 Interrupt
                         DCD      UART0_Handler        ;  38 (0D8H) UART0 Interrupt
                         DCD      UART1_Handler        ;  39 (0DCH) UART1 Interrupt
                         DCD      UART2_Handler        ;  40 (0E0H) UART2 Interrupt
                         DCD      UART3_Handler        ;  41 (0E4H) UART3 Interrupt
                         DCD      TIM0_Handler         ;  42 (0E8H) TIM0 Interrupt
                         DCD      TIM1_Handler         ;  43 (0ECH) TIM1 Interrupt
                         DCD      EXTI15_8_Handler     ;  44 (0F0H) EXTI Line15~8 Interrupt
                         DCD      SDFM_ERR_Handler     ;  45 (0F4H) SDFM Error Interrupt
                         DCD      SDFM_DR1_Handler     ;  46 (0F8H) SDFM Data Ready Interrupt for Ch1
                         DCD      SDFM_DR2_Handler     ;  47 (0FCH) SDFM Data Ready Interrupt for Ch2
                         DCD      SDFM_DR3_Handler     ;  48 (100H) SDFM Data Ready Interrupt for Ch3
                         DCD      SDFM_DR4_Handler     ;  49 (104H) SDFM Data Ready Interrupt for Ch4


__Vectors_End
__Vectors_Size           EQU      __Vectors_End - __Vectors

                         AREA     |.text|, CODE, READONLY
Reset_Handler            PROC
                         EXPORT   Reset_Handler        [WEAK]
                         IMPORT   __main
				                 LDR      R0, =__stack_limit
        				         MSR      MSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI
                         
                         LDR      R0, =SystemInit
                         BLX      R0
               IF  USER_MODE_EN = 1
                         ;switch to user mode
                         LDR      R0, =usr_stack_top
                         MSR      PSP, R0                                      
				                 LDR      R0, =__user_stack_limit
        				         MSR      PSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI
                         MOV      R0,  #3
                         MSR      CONTROL, R0         
               ENDIF                         
                         LDR      R0, =__main
                         BX       R0
                         ENDP    

NMI_Handler              PROC
                         EXPORT   NMI_Handler          [WEAK]
                         B        .
                         ENDP    

HardFault_Handler        PROC
                         EXPORT   HardFault_Handler    [WEAK]
                         B        .
                         ENDP    

MemManage_Handler        PROC
                         EXPORT   MemManage_Handler    [WEAK]
                         B        .
                         ENDP    

BusFault_Handler         PROC
                         EXPORT   BusFault_Handler     [WEAK]
                         B        .
                         ENDP    

UsageFault_Handler       PROC
                         EXPORT   UsageFault_Handler   [WEAK]
                         B        .
                         ENDP    

SVC_Handler              PROC
                         EXPORT   SVC_Handler          [WEAK]
                 IF  USER_MODE_EN = 1
                         ;instruction svc push xPSR,PC,LR,R12,R3,R2,R1,R0
                         TST      LR,   #0x4         ;test return addr bit 2
                         ITE      EQ                 ;if 0
                         MRSEQ    R0,    MSP         ; use main stack
                         MRSNE    R0,    PSP         ; use user stack
                         B        SVC_Call_Proc
                ELSE
                         B        .
                ENDIF
                         ENDP    
                IF  USER_MODE_EN = 1
SVC_Call_Proc            PROC
                         EXPORT   SVC_Call_Proc       [WEAK]
                         BX       LR
                         ENDP
                ENDIF

DebugMon_Handler         PROC
                         EXPORT   DebugMon_Handler     [WEAK]
                         B        .
                         ENDP    

PendSV_Handler           PROC
                         EXPORT   PendSV_Handler       [WEAK]
                         B        .
                         ENDP    

SysTick_Handler          PROC
                         EXPORT   SysTick_Handler      [WEAK]
                         B        .
                         ENDP    

Default_Handler          PROC
                         EXPORT   WWDT_Handler         [WEAK]
                         EXPORT   BOD_Handler          [WEAK]
                         EXPORT   RCC_Handler          [WEAK]
                         EXPORT   EXTI0_Handler        [WEAK]
                         EXPORT   EXTI1_Handler        [WEAK]
                         EXPORT   EXTI2_Handler        [WEAK]
                         EXPORT   EXTI3_Handler        [WEAK]
                         EXPORT   EXTI7_4_Handler      [WEAK]
                         EXPORT   DMA_CH0_Handler      [WEAK]
                         EXPORT   DMA_CH1_Handler      [WEAK]
                         EXPORT   DMA_CH2_Handler      [WEAK]
                         EXPORT   DMA_CH3_Handler      [WEAK]
                         EXPORT   DMA_CH4_Handler      [WEAK]
                         EXPORT   DMA_CH5_7_Handler    [WEAK]
                         EXPORT   MCM0_FLT_Handler     [WEAK]
                         EXPORT   MCM1_FLT_Handler     [WEAK]
                         EXPORT   MCM0_PWM_Handler     [WEAK]
                         EXPORT   MCM1_PWM_Handler     [WEAK]
                         EXPORT   ADC0_Handler         [WEAK]
                         EXPORT   ADC1_Handler         [WEAK]
                         EXPORT   ADC2_Handler         [WEAK]
                         EXPORT   PCA0_FLT_Handler     [WEAK]
                         EXPORT   PCA1_FLT_Handler     [WEAK]
                         EXPORT   PCA2_FLT_Handler     [WEAK]
                         EXPORT   PCA3_FLT_Handler     [WEAK]
                         EXPORT   PCA0_Handler         [WEAK]
                         EXPORT   PCA1_Handler         [WEAK]
                         EXPORT   PCA2_Handler         [WEAK]
                         EXPORT   PCA3_Handler         [WEAK]
                         EXPORT   CMP0_Handler         [WEAK]
                         EXPORT   CMP1_Handler         [WEAK]
                         EXPORT   CMP2_Handler         [WEAK]
                         EXPORT   QEI0_Handler         [WEAK]
                         EXPORT   QEI1_Handler         [WEAK]
                         EXPORT   CAN0_Handler         [WEAK]
                         EXPORT   TWI0_Handler         [WEAK]
                         EXPORT   SPI0_Handler         [WEAK]
                         EXPORT   SPI1_Handler         [WEAK]
                         EXPORT   UART0_Handler        [WEAK]
                         EXPORT   UART1_Handler        [WEAK]
                         EXPORT   UART2_Handler        [WEAK]
                         EXPORT   UART3_Handler        [WEAK]
                         EXPORT   TIM0_Handler         [WEAK]
                         EXPORT   TIM1_Handler         [WEAK]
                         EXPORT   EXTI15_8_Handler     [WEAK]
                         EXPORT   SDFM_ERR_Handler     [WEAK]
                         EXPORT   SDFM_DR1_Handler     [WEAK]
                         EXPORT   SDFM_DR2_Handler     [WEAK]
                         EXPORT   SDFM_DR3_Handler     [WEAK]
                         EXPORT   SDFM_DR4_Handler     [WEAK]
WWDT_Handler
BOD_Handler
RCC_Handler
EXTI0_Handler
EXTI1_Handler
EXTI2_Handler
EXTI3_Handler
EXTI7_4_Handler
DMA_CH0_Handler
DMA_CH1_Handler
DMA_CH2_Handler
DMA_CH3_Handler
DMA_CH4_Handler
DMA_CH5_7_Handler
MCM0_FLT_Handler
MCM1_FLT_Handler
MCM0_PWM_Handler
MCM1_PWM_Handler
ADC0_Handler
ADC1_Handler
ADC2_Handler
PCA0_FLT_Handler
PCA1_FLT_Handler
PCA2_FLT_Handler
PCA3_FLT_Handler
PCA0_Handler
PCA1_Handler
PCA2_Handler
PCA3_Handler
CMP0_Handler
CMP1_Handler
CMP2_Handler
QEI0_Handler
QEI1_Handler
CAN0_Handler
TWI0_Handler
SPI0_Handler
SPI1_Handler
UART0_Handler
UART1_Handler
UART2_Handler
UART3_Handler
TIM0_Handler
TIM1_Handler
EXTI15_8_Handler
SDFM_ERR_Handler
SDFM_DR1_Handler
SDFM_DR2_Handler
SDFM_DR3_Handler
SDFM_DR4_Handler
                         B        .
                         ENDP    

                         
SystemInit  PROC
                EXPORT  SystemInit  [WEAK]
                BX LR      
                ENDP
                    
                ALIGN
                
; User setup Stack & Heap

                EXPORT   __stack_limit
                EXPORT   __initial_sp
                IF       Heap_Size != 0                      ; Heap is provided
                EXPORT   __heap_base
                EXPORT   __heap_limit
                ENDIF

                END
