/*
********************************************************************************
* startup_sh33f2054_gcc.s: Startup file for Sinowealth SH33f2054 device series *
********************************************************************************
* This file is generated for gcc compiler                                      *
********************************************************************************
*	                                                                           *
* SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S    *
* MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS.   *
* THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH *
* SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES   *
* WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR  *
* THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN      *
* CONNECTION WITH THEIR PRODUCTS.                                              *
*                                                                              *
* <h2><center>&copy; COPYRIGHT 2022 Sinowealth</center></h2>                   *
*                                                                              *
********************************************************************************
********************************************************************************
*/

    .syntax unified
    .cpu cortex-m33
    .thumb
    
    .global    Reset_Handler
    .global    __Vectors

    .section  .data.stack,"w"
.skip  0x800   /*stack size*/
_estack:

   
    .section  .isr_vector ,"a",%progbits
 __Vectors:        
    .long    _estack              ;/* -16 (000H) Top of Stack                                  */
     .long    Reset_Handler        ;/* -15 (004H) Reset Handler                                 */
     .long    NMI_Handler          ;/* -14 (008H) Non Maskable Interrupt                        */
     .long    HardFault_Handler    ;/* -13 (00CH) Hard Fault Interrupt                          */
     .long    MemManage_Handler    ;/* -12 (010H) ARM STAR Memory Management Interrupt          */
     .long    BusFault_Handler     ;/* -11 (014H) ARM STAR Bus Fault Interrupt                  */
     .long    UsageFault_Handler   ;/* -10 (018H) ARM STAR Usage Fault Interrupt                */
     .long    Default_Handler      ;/*  -9 (01CH) Reserved                                      */
     .long    Default_Handler      ;/*  -8 (020H) Reserved                                      */
     .long    Default_Handler      ;/*  -7 (024H) Reserved                                      */
     .long    Default_Handler      ;/*  -6 (028H) Reserved                                      */
     .long    SVC_Handler          ;/*  -5 (02CH) ARM STAR SV Call Interrupt                    */
     .long    DebugMon_Handler     ;/*  -4 (030H) ARM STAR Debug Monitor Interrupt              */
     .long    Default_Handler      ;/*  -3 (034H) Reserved                                      */
     .long    PendSV_Handler       ;/*  -2 (038H) ARM STAR Pend SV Interrupt                    */
     .long    SysTick_Handler      ;/*  -1 (03CH) ARM STAR System Tick Interrupt                */
     .long    WWDT_Handler         ;/*   0 (040H) Window WatchDog Interrupt                     */
     .long    BOD_Handler          ;/*   1 (044H) PVD through EXTI Line detection Interrupt     */
     .long    RCC_Handler          ;/*   2 (048H) RCC global Interrupt                          */
     .long    EXTI0_Handler        ;/*   3 (04CH) EXTI Line0 Interrupt                          */
     .long    EXTI1_Handler        ;/*   4 (050H) EXTI Line1 Interrupt                          */
     .long    EXTI2_Handler        ;/*   5 (054H) EXTI Line2 Interrupt                          */
     .long    EXTI3_Handler        ;/*   6 (058H) EXTI Line3 Interrupt                          */
     .long    EXTI7_4_Handler      ;/*   7 (05CH) EXTI Line4~7 Interrupt                        */
     .long    DMA_CH0_Handler      ;/*   8 (060H) DMA Channe0 Interrupt                         */
     .long    DMA_CH1_Handler      ;/*   9 (064H) DMA Channe1 Interrupt                         */
     .long    DMA_CH2_Handler      ;/*  10 (068H) DMA Channe2 Interrupt                         */
     .long    DMA_CH3_Handler      ;/*  11 (06CH) DMA Channe3 Interrupt                         */
     .long    DMA_CH4_Handler      ;/*  12 (070H) DMA Channe4 Interrupt                         */
     .long    DMA_CH5_7_Handler    ;/*  13 (074H) DMA Channe5~7 Interrupt                       */
     .long    MCM0_FLT_Handler     ;/*  14 (078H) MCM FAULT Interrupt                           */
     .long    MCM1_FLT_Handler     ;/*  15 (07CH) MCM FAULT Interrupt                           */
     .long    MCM0_PWM_Handler     ;/*  16 (080H) MCM PWM Interrupt                             */
     .long    MCM1_PWM_Handler     ;/*  17 (084H) MCM PWM Interrupt                             */
     .long    ADC0_Handler         ;/*  18 (088H) ADC0 Interrupt                                */
     .long    ADC1_Handler         ;/*  19 (08CH) ADC1 Interrupt                                */
     .long    ADC2_Handler         ;/*  20 (090H) ADC2 Interrupt                                */
     .long    PCA0_FLT_Handler     ;/*  21 (094H) PCA0 Fault Interrupt                          */
     .long    PCA1_FLT_Handler     ;/*  22 (098H) PCA1 Fault Interrupt                          */
     .long    PCA2_FLT_Handler     ;/*  23 (09CH) PCA2 Fault Interrupt                          */
     .long    PCA3_FLT_Handler     ;/*  24 (0A0H) PCA3 Fault Interrupt                          */
     .long    PCA0_Handler         ;/*  25 (0A4H) PCA0 Interrupt                                */
     .long    PCA1_Handler         ;/*  26 (0A8H) PCA1 Interrupt                                */
     .long    PCA2_Handler         ;/*  27 (0ACH) PCA2 Interrupt                                */
     .long    PCA3_Handler         ;/*  28 (0B0H) PCA3 Interrupt                                */
     .long    CMP0_Handler         ;/*  29 (0B4H) CMP0 Interrupt                                */
     .long    CMP1_Handler         ;/*  30 (0B8H) CMP1 Interrupt                                */
     .long    CMP2_Handler         ;/*  31 (0BCH) CMP2 Interrupt                                */
     .long    QEI0_Handler         ;/*  32 (0C0H) QEI Interrupt                                 */
     .long    QEI1_Handler         ;/*  33 (0C4H) QEI Interrupt                                 */
     .long    CAN0_Handler         ;/*  34 (0C8H) CAN0 Interrupt                                */
     .long    TWI0_Handler         ;/*  35 (0CCH) TWI0 Interrupt                                */
     .long    SPI0_Handler         ;/*  36 (0D0H) SPI0 Interrupt                                */
     .long    SPI1_Handler         ;/*  37 (0D4H) SPI1 Interrupt                                */
     .long    UART0_Handler        ;/*  38 (0D8H) UART0 Interrupt                               */
     .long    UART1_Handler        ;/*  39 (0DCH) UART1 Interrupt                               */
     .long    UART2_Handler        ;/*  40 (0E0H) UART2 Interrupt                               */
     .long    UART3_Handler        ;/*  41 (0E4H) UART3 Interrupt                               */
     .long    TIM0_Handler         ;/*  42 (0E8H) TIM0 Interrupt                                */
     .long    TIM1_Handler         ;/*  43 (0ECH) TIM1 Interrupt                                */
     .long    EXTI15_8_Handler     ;/*  44 (0F0H) EXTI Line15~8 Interrupt                       */
     .long    SDFM_ERR_Handler     ;/*  45 (0F4H) SDFM Error Interrupt                          */
     .long    SDFM_DR1_Handler     ;/*  46 (0F8H) SDFM Data Ready Interrupt for Ch1             */
     .long    SDFM_DR2_Handler     ;/*  47 (0FCH) SDFM Data Ready Interrupt for Ch2             */
     .long    SDFM_DR3_Handler     ;/*  48 (100H) SDFM Data Ready Interrupt for Ch3             */
     .long    SDFM_DR4_Handler     ;/*  49 (104H) SDFM Data Ready Interrupt for Ch4             */
    
      .section  .text.Reset_Handler,"ax",%progbits
      .type Reset_Handler, %function
Reset_Handler:
    ldr  sp, =_estack

    /* Call the low level init function.*/
    bl  SystemInit   
    
    movs r1, #0
    b    LoopCopyDataInit

CopyDataInit:
    ldr  r3, =_sidata
    ldr  r3, [r3, r1]
    str  r3, [r0, r1]
    adds r1, r1, #4
    
LoopCopyDataInit:
    ldr  r0, =_sdata
    ldr  r3, =_edata
    adds r2, r0, r1
    cmp  r2, r3
    bcc  CopyDataInit
    ldr  r2, =_sbss
    b    LoopFillZerobss
  
    ;/* Zero fill the bss segment. */  

FillZerobss:
    movs r3, #0
    str  r3, [r2], #4
    
LoopFillZerobss:
    ldr r3, =_ebss
    cmp r2, r3
    bcc FillZerobss
  
   /* Call static constructors */
   /* bl  __libc_init_array*/
	
  /* Call the application's entry point.*/
    bl  main
    bx  lr    
    b  .  
    
    .size  Reset_Handler, .-Reset_Handler
    
    .weak      NMI_Handler
    .thumb_set NMI_Handler,          System_Handler
  
    .weak      HardFault_Handler
    .thumb_set HardFault_Handler,    System_Handler
  
    .weak      MemManage_Handler
    .thumb_set MemManage_Handler,    System_Handler
  
    .weak      BusFault_Handler
    .thumb_set BusFault_Handler,     System_Handler

    .weak      UsageFault_Handler
    .thumb_set UsageFault_Handler,   System_Handler

    .weak      SVC_Handler
    .thumb_set SVC_Handler,          System_Handler

    .weak      DebugMon_Handler
    .thumb_set DebugMon_Handler,     System_Handler

    .weak      PendSV_Handler
    .thumb_set PendSV_Handler,       System_Handler

    .weak      SysTick_Handler
    .thumb_set SysTick_Handler,      System_Handler    

    .weak      WWDT_Handler        
    .thumb_set WWDT_Handler,        User_Handler
    .weak      BOD_Handler         
    .thumb_set BOD_Handler,         User_Handler
    .weak      RCC_Handler         
    .thumb_set RCC_Handler,         User_Handler
    .weak      EXTI0_Handler       
    .thumb_set EXTI0_Handler,       User_Handler
    .weak      EXTI1_Handler       
    .thumb_set EXTI1_Handler,       User_Handler
    .weak      EXTI2_Handler       
    .thumb_set EXTI2_Handler,       User_Handler
    .weak      EXTI3_Handler       
    .thumb_set EXTI3_Handler,       User_Handler
    .weak      EXTI7_4_Handler     
    .thumb_set EXTI7_4_Handler,     User_Handler
    .weak      DMA_CH0_Handler     
    .thumb_set DMA_CH0_Handler,     User_Handler
    .weak      DMA_CH1_Handler     
    .thumb_set DMA_CH1_Handler,     User_Handler
    .weak      DMA_CH2_Handler     
    .thumb_set DMA_CH2_Handler,     User_Handler
    .weak      DMA_CH3_Handler     
    .thumb_set DMA_CH3_Handler,     User_Handler
    .weak      DMA_CH4_Handler     
    .thumb_set DMA_CH4_Handler,     User_Handler
    .weak      DMA_CH5_7_Handler   
    .thumb_set DMA_CH5_7_Handler,   User_Handler
    .weak      MCM0_FLT_Handler    
    .thumb_set MCM0_FLT_Handler,    User_Handler
    .weak      MCM1_FLT_Handler    
    .thumb_set MCM1_FLT_Handler,    User_Handler
    .weak      MCM0_PWM_Handler    
    .thumb_set MCM0_PWM_Handler,    User_Handler
    .weak      MCM1_PWM_Handler    
    .thumb_set MCM1_PWM_Handler,    User_Handler
    .weak      ADC0_Handler        
    .thumb_set ADC0_Handler,        User_Handler
    .weak      ADC1_Handler        
    .thumb_set ADC1_Handler,        User_Handler
    .weak      ADC2_Handler        
    .thumb_set ADC2_Handler,        User_Handler
    .weak      PCA0_FLT_Handler    
    .thumb_set PCA0_FLT_Handler,    User_Handler
    .weak      PCA1_FLT_Handler    
    .thumb_set PCA1_FLT_Handler,    User_Handler
    .weak      PCA2_FLT_Handler    
    .thumb_set PCA2_FLT_Handler,    User_Handler
    .weak      PCA3_FLT_Handler    
    .thumb_set PCA3_FLT_Handler,    User_Handler
    .weak      PCA0_Handler        
    .thumb_set PCA0_Handler,        User_Handler
    .weak      PCA1_Handler        
    .thumb_set PCA1_Handler,        User_Handler
    .weak      PCA2_Handler        
    .thumb_set PCA2_Handler,        User_Handler
    .weak      PCA3_Handler        
    .thumb_set PCA3_Handler,        User_Handler
    .weak      CMP0_Handler        
    .thumb_set CMP0_Handler,        User_Handler
    .weak      CMP1_Handler        
    .thumb_set CMP1_Handler,        User_Handler
    .weak      CMP2_Handler        
    .thumb_set CMP2_Handler,        User_Handler
    .weak      QEI0_Handler        
    .thumb_set QEI0_Handler,        User_Handler
    .weak      QEI1_Handler        
    .thumb_set QEI1_Handler,        User_Handler
    .weak      CAN0_Handler        
    .thumb_set CAN0_Handler,        User_Handler
    .weak      TWI0_Handler        
    .thumb_set TWI0_Handler,        User_Handler
    .weak      SPI0_Handler        
    .thumb_set SPI0_Handler,        User_Handler
    .weak      SPI1_Handler        
    .thumb_set SPI1_Handler,        User_Handler
    .weak      UART0_Handler       
    .thumb_set UART0_Handler,       User_Handler
    .weak      UART1_Handler       
    .thumb_set UART1_Handler,       User_Handler
    .weak      UART2_Handler       
    .thumb_set UART2_Handler,       User_Handler
    .weak      UART3_Handler       
    .thumb_set UART3_Handler,       User_Handler
    .weak      TIM0_Handler        
    .thumb_set TIM0_Handler,        User_Handler
    .weak      TIM1_Handler        
    .thumb_set TIM1_Handler,        User_Handler
    .weak      EXTI15_8_Handler    
    .thumb_set EXTI15_8_Handler,    User_Handler
    .weak      SDFM_ERR_Handler    
    .thumb_set SDFM_ERR_Handler,    User_Handler
    .weak      SDFM_DR1_Handler    
    .thumb_set SDFM_DR1_Handler,    User_Handler
    .weak      SDFM_DR2_Handler    
    .thumb_set SDFM_DR2_Handler,    User_Handler
    .weak      SDFM_DR3_Handler    
    .thumb_set SDFM_DR3_Handler,    User_Handler
    .weak      SDFM_DR4_Handler    
    .thumb_set SDFM_DR4_Handler,    User_Handler
   
    .section  .text.System_Handler,"ax",%progbits
    .type System_Handler, %function
System_Handler:
   b  .
   .size  System_Handler, .-System_Handler
   
    .section  .text.Default_Handler,"ax",%progbits
    .type Default_Handler, %function
Default_Handler:
   b  .   
   .size  Default_Handler, .-Default_Handler

 
    .section  .text.User_Handler,"ax",%progbits
    .type User_Handler, %function
User_Handler:
   b  .
   .size  User_Handler, .-User_Handler
               
   .weak SystemInit
   .thumb_set SystemInit, SystemInit_Default
   .section  .text.SystemInit,"ax",%progbits   
   .type SystemInit_Default, %function
SystemInit_Default:
   bx lr
   .size SystemInit_Default, .-SystemInit_Default
   
