;/******************** (C) COPYRIGHT 2017 Sinowealth ********************
;* File Name          : startup_sh3xf2xx_iar.s
;* Author             : MCD Application Team
;* Version            : V1.0.0
;* Date               : 07-March-2017
;* Description        : SH3xF2xx devices vector table for EWARM toolchain.
;*                      This module performs:
;*                      - Set the initial SP
;*                      - Set the initial PC == _iar_program_start,
;*                      - Set the vector table entries with the exceptions ISR 
;*                        address.
;*                      - Branches to main in the C library (which eventually
;*                        calls main()).
;*                      After Reset the Cortex-M3 processor is in Thread mode,
;*                      priority is Privileged, and the Stack is set to Main.
;********************************************************************************
;* 
;* Redistribution and use in source and binary forms, with or without modification,
;* are permitted provided that the following conditions are met:
;*   1. Redistributions of source code must retain the above copyright notice,
;*      this list of conditions and the following disclaimer.
;*   2. Redistributions in binary form must reproduce the above copyright notice,
;*      this list of conditions and the following disclaimer in the documentation
;*      and/or other materials provided with the distribution.
;*   3. Neither the name of STMicroelectronics nor the names of its contributors
;*      may be used to endorse or promote products derived from this software
;*      without specific prior written permission.
;*
;* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
;* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
;* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
;* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
;* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
;* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;* 
;*******************************************************************************
; *
; * SINOWEALTH IS SUPPLYING THIS SOFTWARE FOR USE EXCLUSIVELY ON SINOWEALTH'S 
; * MICROCONTROLLER PRODUCTS. IT IS PROTECTED UNDER APPLICABLE COPYRIGHT LAWS. 
; * THIS SOFTWARE IS FOR GUIDANCE IN ORDER TO SAVE TIME. AS A RESULT, SINOWEALTH 
; * SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES 
; * WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF SUCH FIRMWARE AND/OR
; * THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN 
; * CONNECTION WITH THEIR PRODUCTS.
; *
; * <h2><center>&copy; COPYRIGHT 2017 Sinowealth</center></h2>
; *
; ******************************************************************************
; */
;
;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__Vectors" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version
;



        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT (3)

        SECTION .intvec:CODE:NOROOT (2)

        EXTERN  __iar_program_start
        PUBLIC  __Vectors

        DATA
__Vectors

     DCD      sfe(CSTACK)          ;/* -16 (000H) Top of Stack                                  */
     DCD      Reset_Handler        ;/* -15 (004H) Reset Handler                                 */
     DCD      NMI_Handler          ;/* -14 (008H) Non Maskable Interrupt                        */
     DCD      HardFault_Handler    ;/* -13 (00CH) Hard Fault Interrupt                          */
     DCD      MemManage_Handler    ;/* -12 (010H) ARM STAR Memory Management Interrupt          */
     DCD      BusFault_Handler     ;/* -11 (014H) ARM STAR Bus Fault Interrupt                  */
     DCD      UsageFault_Handler   ;/* -10 (018H) ARM STAR Usage Fault Interrupt                */
     DCD      Default_Handler      ;/*  -9 (01CH) Reserved                                      */
     DCD      Default_Handler      ;/*  -8 (020H) Reserved                                      */
     DCD      Default_Handler      ;/*  -7 (024H) Reserved                                      */
     DCD      Default_Handler      ;/*  -6 (028H) Reserved                                      */
     DCD      SVC_Handler          ;/*  -5 (02CH) ARM STAR SV Call Interrupt                    */
     DCD      DebugMon_Handler     ;/*  -4 (030H) ARM STAR Debug Monitor Interrupt              */
     DCD      Default_Handler      ;/*  -3 (034H) Reserved                                      */
     DCD      PendSV_Handler       ;/*  -2 (038H) ARM STAR Pend SV Interrupt                    */
     DCD      SysTick_Handler      ;/*  -1 (03CH) ARM STAR System Tick Interrupt                */
     DCD      WWDT_Handler         ;/*   0 (040H) Window WatchDog Interrupt                     */
     DCD      BOD_Handler          ;/*   1 (044H) PVD through EXTI Line detection Interrupt     */
     DCD      RCC_Handler          ;/*   2 (048H) RCC global Interrupt                          */
     DCD      EXTI0_Handler        ;/*   3 (04CH) EXTI Line0 Interrupt                          */
     DCD      EXTI1_Handler        ;/*   4 (050H) EXTI Line1 Interrupt                          */
     DCD      EXTI2_Handler        ;/*   5 (054H) EXTI Line2 Interrupt                          */
     DCD      EXTI3_Handler        ;/*   6 (058H) EXTI Line3 Interrupt                          */
     DCD      EXTI7_4_Handler      ;/*   7 (05CH) EXTI Line4~7 Interrupt                        */
     DCD      DMA_CH0_Handler      ;/*   8 (060H) DMA Channe0 Interrupt                         */
     DCD      DMA_CH1_Handler      ;/*   9 (064H) DMA Channe1 Interrupt                         */
     DCD      DMA_CH2_Handler      ;/*  10 (068H) DMA Channe2 Interrupt                         */
     DCD      DMA_CH3_Handler      ;/*  11 (06CH) DMA Channe3 Interrupt                         */
     DCD      DMA_CH4_Handler      ;/*  12 (070H) DMA Channe4 Interrupt                         */
     DCD      DMA_CH5_7_Handler    ;/*  13 (074H) DMA Channe5~7 Interrupt                       */
     DCD      MCM0_FLT_Handler     ;/*  14 (078H) MCM FAULT Interrupt                           */
     DCD      MCM1_FLT_Handler     ;/*  15 (07CH) MCM FAULT Interrupt                           */
     DCD      MCM0_PWM_Handler     ;/*  16 (080H) MCM PWM Interrupt                             */
     DCD      MCM1_PWM_Handler     ;/*  17 (084H) MCM PWM Interrupt                             */
     DCD      ADC0_Handler         ;/*  18 (088H) ADC0 Interrupt                                */
     DCD      ADC1_Handler         ;/*  19 (08CH) ADC1 Interrupt                                */
     DCD      ADC2_Handler         ;/*  20 (090H) ADC2 Interrupt                                */
     DCD      PCA0_FLT_Handler     ;/*  21 (094H) PCA0 Fault Interrupt                          */
     DCD      PCA1_FLT_Handler     ;/*  22 (098H) PCA1 Fault Interrupt                          */
     DCD      PCA2_FLT_Handler     ;/*  23 (09CH) PCA2 Fault Interrupt                          */
     DCD      PCA3_FLT_Handler     ;/*  24 (0A0H) PCA3 Fault Interrupt                          */
     DCD      PCA0_Handler         ;/*  25 (0A4H) PCA0 Interrupt                                */
     DCD      PCA1_Handler         ;/*  26 (0A8H) PCA1 Interrupt                                */
     DCD      PCA2_Handler         ;/*  27 (0ACH) PCA2 Interrupt                                */
     DCD      PCA3_Handler         ;/*  28 (0B0H) PCA3 Interrupt                                */
     DCD      CMP0_Handler         ;/*  29 (0B4H) CMP0 Interrupt                                */
     DCD      CMP1_Handler         ;/*  30 (0B8H) CMP1 Interrupt                                */
     DCD      CMP2_Handler         ;/*  31 (0BCH) CMP2 Interrupt                                */
     DCD      QEI0_Handler         ;/*  32 (0C0H) QEI Interrupt                                 */
     DCD      QEI1_Handler         ;/*  33 (0C4H) QEI Interrupt                                 */
     DCD      CAN0_Handler         ;/*  34 (0C8H) CAN0 Interrupt                                */
     DCD      TWI0_Handler         ;/*  35 (0CCH) TWI0 Interrupt                                */
     DCD      SPI0_Handler         ;/*  36 (0D0H) SPI0 Interrupt                                */
     DCD      SPI1_Handler         ;/*  37 (0D4H) SPI1 Interrupt                                */
     DCD      UART0_Handler        ;/*  38 (0D8H) UART0 Interrupt                               */
     DCD      UART1_Handler        ;/*  39 (0DCH) UART1 Interrupt                               */
     DCD      UART2_Handler        ;/*  40 (0E0H) UART2 Interrupt                               */
     DCD      UART3_Handler        ;/*  41 (0E4H) UART3 Interrupt                               */
     DCD      TIM0_Handler         ;/*  42 (0E8H) TIM0 Interrupt                                */
     DCD      TIM1_Handler         ;/*  43 (0ECH) TIM1 Interrupt                                */
     DCD      EXTI15_8_Handler     ;/*  44 (0F0H) EXTI Line15~8 Interrupt                       */
     DCD      SDFM_ERR_Handler     ;/*  45 (0F4H) SDFM Error Interrupt                          */
     DCD      SDFM_DR1_Handler     ;/*  46 (0F8H) SDFM Data Ready Interrupt for Ch1             */
     DCD      SDFM_DR2_Handler     ;/*  47 (0FCH) SDFM Data Ready Interrupt for Ch2             */
     DCD      SDFM_DR3_Handler     ;/*  48 (100H) SDFM Data Ready Interrupt for Ch3             */
     DCD      SDFM_DR4_Handler     ;/*  49 (104H) SDFM Data Ready Interrupt for Ch4             */


	THUMB
	PUBWEAK Reset_Handler
	SECTION .text:CODE:REORDER:NOROOT(2)
Reset_Handler
				LDR      R0, =sfb(CSTACK)                    ; section of begin
        MSR      MSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI
	
        LDR     R0, =SystemInit
        BLX     R0
        LDR     R0, =__iar_program_start
        BX      R0
	
	PUBWEAK SystemInit
	SECTION .text:CODE:REORDER:NOROOT(1)
SystemInit
	BX LR
	
	PUBWEAK NMI_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
NMI_Handler
	B NMI_Handler	

	PUBWEAK HardFault_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
HardFault_Handler
	B HardFault_Handler
	
	PUBWEAK MemManage_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
MemManage_Handler
	B MemManage_Handler

	PUBWEAK BusFault_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
BusFault_Handler
	B BusFault_Handler

	PUBWEAK UsageFault_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
UsageFault_Handler
	B UsageFault_Handler

	PUBWEAK SVC_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
SVC_Handler
	B SVC_Handler

	PUBWEAK DebugMon_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
DebugMon_Handler
	B DebugMon_Handler

	PUBWEAK PendSV_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
PendSV_Handler
	B PendSV_Handler

	PUBWEAK SysTick_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
SysTick_Handler
	B SysTick_Handler
	
					
    PUBWEAK    WWDT_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
WWDT_Handler        
    B WWDT_Handler        
    PUBWEAK    BOD_Handler         
    SECTION .text:CODE:REORDER:NOROOT(1)
BOD_Handler         
    B BOD_Handler         
    PUBWEAK    RCC_Handler         
    SECTION .text:CODE:REORDER:NOROOT(1)
RCC_Handler         
    B RCC_Handler         
    PUBWEAK    EXTI0_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI0_Handler       
    B EXTI0_Handler       
    PUBWEAK    EXTI1_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI1_Handler       
    B EXTI1_Handler       
    PUBWEAK    EXTI2_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI2_Handler       
    B EXTI2_Handler       
    PUBWEAK    EXTI3_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI3_Handler       
    B EXTI3_Handler       
    PUBWEAK    EXTI7_4_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI7_4_Handler     
    B EXTI7_4_Handler     
    PUBWEAK    DMA_CH0_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH0_Handler     
    B DMA_CH0_Handler     
    PUBWEAK    DMA_CH1_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH1_Handler     
    B DMA_CH1_Handler     
    PUBWEAK    DMA_CH2_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH2_Handler     
    B DMA_CH2_Handler     
    PUBWEAK    DMA_CH3_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH3_Handler     
    B DMA_CH3_Handler     
    PUBWEAK    DMA_CH4_Handler     
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH4_Handler     
    B DMA_CH4_Handler     
    PUBWEAK    DMA_CH5_7_Handler   
    SECTION .text:CODE:REORDER:NOROOT(1)
DMA_CH5_7_Handler   
    B DMA_CH5_7_Handler   
    PUBWEAK    MCM0_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
MCM0_FLT_Handler    
    B MCM0_FLT_Handler    
    PUBWEAK    MCM1_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
MCM1_FLT_Handler    
    B MCM1_FLT_Handler    
    PUBWEAK    MCM0_PWM_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
MCM0_PWM_Handler    
    B MCM0_PWM_Handler    
    PUBWEAK    MCM1_PWM_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
MCM1_PWM_Handler    
    B MCM1_PWM_Handler    
    PUBWEAK    ADC0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
ADC0_Handler        
    B ADC0_Handler        
    PUBWEAK    ADC1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
ADC1_Handler        
    B ADC1_Handler        
    PUBWEAK    ADC2_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
ADC2_Handler        
    B ADC2_Handler        
    PUBWEAK    PCA0_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA0_FLT_Handler    
    B PCA0_FLT_Handler    
    PUBWEAK    PCA1_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA1_FLT_Handler    
    B PCA1_FLT_Handler    
    PUBWEAK    PCA2_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA2_FLT_Handler    
    B PCA2_FLT_Handler    
    PUBWEAK    PCA3_FLT_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA3_FLT_Handler    
    B PCA3_FLT_Handler    
    PUBWEAK    PCA0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA0_Handler        
    B PCA0_Handler        
    PUBWEAK    PCA1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA1_Handler        
    B PCA1_Handler        
    PUBWEAK    PCA2_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA2_Handler        
    B PCA2_Handler        
    PUBWEAK    PCA3_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
PCA3_Handler        
    B PCA3_Handler        
    PUBWEAK    CMP0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
CMP0_Handler        
    B CMP0_Handler        
    PUBWEAK    CMP1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
CMP1_Handler        
    B CMP1_Handler        
    PUBWEAK    CMP2_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
CMP2_Handler        
    B CMP2_Handler        
    PUBWEAK    QEI0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
QEI0_Handler        
    B QEI0_Handler        
    PUBWEAK    QEI1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
QEI1_Handler        
    B QEI1_Handler        
    PUBWEAK    CAN0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
CAN0_Handler        
    B CAN0_Handler        
    PUBWEAK    TWI0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TWI0_Handler        
    B TWI0_Handler        
    PUBWEAK    SPI0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
SPI0_Handler        
    B SPI0_Handler        
    PUBWEAK    SPI1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
SPI1_Handler        
    B SPI1_Handler        
    PUBWEAK    UART0_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART0_Handler       
    B UART0_Handler       
    PUBWEAK    UART1_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART1_Handler       
    B UART1_Handler       
    PUBWEAK    UART2_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART2_Handler       
    B UART2_Handler       
    PUBWEAK    UART3_Handler       
    SECTION .text:CODE:REORDER:NOROOT(1)
UART3_Handler       
    B UART3_Handler       
    PUBWEAK    TIM0_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM0_Handler        
    B TIM0_Handler        
    PUBWEAK    TIM1_Handler        
    SECTION .text:CODE:REORDER:NOROOT(1)
TIM1_Handler        
    B TIM1_Handler        
    PUBWEAK    EXTI15_8_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
EXTI15_8_Handler    
    B EXTI15_8_Handler    
    PUBWEAK    SDFM_ERR_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
SDFM_ERR_Handler    
    B SDFM_ERR_Handler    
    PUBWEAK    SDFM_DR1_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
SDFM_DR1_Handler    
    B SDFM_DR1_Handler    
    PUBWEAK    SDFM_DR2_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
SDFM_DR2_Handler    
    B SDFM_DR2_Handler    
    PUBWEAK    SDFM_DR3_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
SDFM_DR3_Handler    
    B SDFM_DR3_Handler    
    PUBWEAK    SDFM_DR4_Handler    
    SECTION .text:CODE:REORDER:NOROOT(1)
SDFM_DR4_Handler    
    B SDFM_DR4_Handler    
	
	PUBWEAK Default_Handler
	SECTION .text:CODE:REORDER:NOROOT(1)
Default_Handler
	B Default_Handler
	
	END
/*********************** (C) COPYRIGHT STMicroelectronics *** END OF FILE*****/	
	
	
