/**
  ******************************************************************************
  * @file    sh3xf2xx_sc0_int.c 
  * @author  
  * @version V1.1.0
  * @date    07-March-2022
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "sh3xf2xx_sc0_int.h"

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            ARM Star Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */  
/* NMI ISR Handler template, uncomment it for using*/
//void NMI_Handler(void)
//{
//}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void HardFault_Handler(void)
//{
//  /* Go to infinite loop when Hard Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
/* Memory Manage ISR Handler template, uncomment it for using*/
//void MemManage_Handler(void)
//{
  /* Go to infinite loop when Memory Manage exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
/* Bus Fault ISR Handler template, uncomment it for using*/
//void BusFault_Handler(void)
//{
  /* Go to infinite loop when Bus Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
/* Usage Fault ISR Handler template, uncomment it for using*/
//void UsageFault_Handler(void)
//{
  /* Go to infinite loop when Usage Fault exception occurs */
//  while (1)
//  {
//  }
//}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void SVC_Handler(void)
//{
//}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void DebugMon_Handler(void)
//{
//}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void PendSV_Handler(void)
//{
//}

/**
  * @brief  This function handles SysTick exception.
  * @param  None
  * @retval None
  */
/* HardFault ISR Handler template, uncomment it for using*/
//void SysTick_Handler(void)
//{
//}

/******************************************************************************/
/*                 SH32F205 Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_sh32f205_xxx.s).                                               */
/******************************************************************************/

/**
  * @brief  This function handles WWDT interrupt request.
  * @param  None
  * @retval None
  */
//void WWDT_Handler      (void) //   0 (040H) Window WatchDog Interrupt
//{
//}

/**
  * @brief  This function handles BOD interrupt request.
  * @param  None
  * @retval None
  */
//void BOD_Handler       (void) //   1 (044H) PVD through EXTI Line detection Interrupt
//{
//}

/**
  * @brief  This function handles RCC interrupt request.
  * @param  None
  * @retval None
  */
//void RCC_Handler       (void) //   2 (048H) RCC global Interrupt
//{
//}

/**
  * @brief  This function handles EXTI0 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI0_Handler     (void) //   3 (04CH) EXTI Line0 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI1 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI1_Handler     (void) //   4 (050H) EXTI Line1 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI2 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI2_Handler     (void) //   5 (054H) EXTI Line2 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI3 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI3_Handler     (void) //   6 (058H) EXTI Line3 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI4 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI7_4_Handler     (void) //   7 (05CH) EXTI Line4 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 0 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH0_Handler     (void) //   8 (060H) DMA Channe0 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 1 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH1_Handler   (void) //   9 (064H) DMA Channe1 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 2 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH2_Handler   (void) //  10 (068H) DMA Channe2 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 3 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH3_Handler   (void) //  11 (06CH) DMA Channe3 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 4 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH4_Handler   (void) //  12 (070H) DMA Channe4 Interrupt
//{
//}

/**
  * @brief  This function handles DMA channel 5~7 interrupt request.
  * @param  None
  * @retval None
  */
//void DMA_CH5_7_Handler (void) //  13 (074H) DMA Channe5~7 Interrupt
//{
//}

/**
  * @brief  This function handles MCM0 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void MCM0_FLT_Handler  (void) //  14 (078H) MCM0 FAULT Interrupt
//{
//}

/**
  * @brief  This function handles MCM1 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void MCM1_FLT_Handler  (void) //  15 (07CH) MCM1 FAULT Interrupt
//{
//}

/**
  * @brief  This function handles MCM0 interrupt request.
  * @param  None
  * @retval None
  */
//void MCM0_PWM_Handler  (void) //  16 (080H) MCM0 PWM Interrupt
//{
//}

/**
  * @brief  This function handles MCM1 interrupt request.
  * @param  None
  * @retval None
  */
//void MCM1_PWM_Handler  (void) //  17 (084H) MCM1 PWM Interrupt
//{
//}

/**
  * @brief  This function handles ADC0 interrupt request.
  * @param  None
  * @retval None
  */
//void ADC0_Handler      (void) //  18 (088H) ADC0 Interrupt
//{
//}

/**
  * @brief  This function handles ADC1 interrupt request.
  * @param  None
  * @retval None
  */
//void ADC1_Handler      (void) //  19 (08CH) ADC1 Interrupt
//{
//}

/**
  * @brief  This function handles ADC2 interrupt request.
  * @param  None
  * @retval None
  */
//void ADC2_Handler      (void) //  20 (090H) ADC2 Interrupt
//{
//}

/**
  * @brief  This function handles PCA0 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA0_FLT_Handler  (void) //  21 (094H) PCA0 Fault Interrupt
//{
//}

/**
  * @brief  This function handles PCA1 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA1_FLT_Handler  (void) //  22 (098H) PCA1 Fault Interrupt
//{
//}

/**
  * @brief  This function handles PCA2 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA2_FLT_Handler  (void) //  23 (09CH) PCA2 Fault Interrupt
//{
//}

/**
  * @brief  This function handles PCA3 Fault interrupt request.
  * @param  None
  * @retval None
  */
//void PCA3_FLT_Handler  (void) //  24 (0A0H) PCA3 Fault Interrupt
//{
//}

/**
  * @brief  This function handles PCA0 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA0_Handler      (void) //  25 (0A4H) PCA0 Interrupt
//{
//}

/**
  * @brief  This function handles PCA1 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA1_Handler      (void) //  26 (0A8H) PCA1 Interrupt
//{
//}

/**
  * @brief  This function handles PCA2 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA2_Handler      (void) //  27 (0ACH) PCA2 Interrupt
//{
//}

/**
  * @brief  This function handles PCA3 interrupt request.
  * @param  None
  * @retval None
  */
//void PCA3_Handler      (void) //  28 (0B0H) PCA3 Interrupt
//{
//}

/**
  * @brief  This function handles CMP0 interrupt request.
  * @param  None
  * @retval None
  */
//void CMP0_Handler      (void) //  29 (0B4H) CMP0 Interrupt
//{
//}

/**
  * @brief  This function handles CMP1 interrupt request.
  * @param  None
  * @retval None
  */
//void CMP1_Handler      (void) //  30 (0B8H) CMP1 Interrupt
//{
//}

/**
  * @brief  This function handles CMP2 interrupt request.
  * @param  None
  * @retval None
  */
//void CMP2_Handler      (void) //  31 (0BCH) CMP2 Interrupt
//{
//}

/**
  * @brief  This function handles QEI interrupt request.
  * @param  None
  * @retval None
  */
//void QEI_Handler       (void) //  32 (0C0H) QEI Interrupt
//{
//}

/**
  * @brief  This function handles CAN0 interrupt request.
  * @param  None
  * @retval None
  */
//void CAN0_Handler      (void) //  33 (0C4H) CAN0 Interrupt
//{
//}

/**
  * @brief  This function handles TWI0 interrupt request.
  * @param  None
  * @retval None
  */
//void TWI0_Handler      (void) //  34 (0C8H) TWI0 Interrupt
//{
//}

/**
  * @brief  This function handles SPI0 interrupt request.
  * @param  None
  * @retval None
  */
//void SPI0_Handler      (void) //  35 (0CCH) SPI0 Interrupt
//{
//}

/**
  * @brief  This function handles SPI1 interrupt request.
  * @param  None
  * @retval None
  */
//void SPI1_Handler      (void) //  36 (0D0H) SPI1 Interrupt
//{
//}

/**
  * @brief  This function handles Uart0 interrupt request.
  * @param  None
  * @retval None
  */
//void UART0_Handler     (void) //  37 (0D4H) UART0 Interrupt
//{
//}

/**
  * @brief  This function handles Uart1 interrupt request.
  * @param  None
  * @retval None
  */
//void UART1_Handler     (void) //  38 (0D8H) UART1 Interrupt
//{
//}

/**
  * @brief  This function handles Uart2 interrupt request.
  * @param  None
  * @retval None
  */
//void UART2_Handler     (void) //  39 (0DCH) UART2 Interrupt
//{
//}

/**
  * @brief  This function handles Uart3 interrupt request.
  * @param  None
  * @retval None
  */
//void UART3_Handler     (void) //  40 (0E0H) UART3 Interrupt
//{
//}

/**
  * @brief  This function handles Timer0 interrupt request.
  * @param  None
  * @retval None
  */
//void TIM0_Handler      (void) //  41 (0E4H) TIM0 Interrupt
//{
//}

/**
  * @brief  This function handles Timer1 interrupt request.
  * @param  None
  * @retval None
  */
//void TIM1_Handler      (void) //  42 (0E8H) TIM1 Interrupt
//{
//}

/**
  * @brief  This function handles EXTI 15~8 interrupt request.
  * @param  None
  * @retval None
  */
//void EXTI15_8_Handler  (void) //  43 (0ECH) EXTI Line8 ~ Line15 Interrupt
//{
//}

/**
  * @}
  */ 


/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
