/**
  ******************************************************************************
  * @file    sh3xf2xx_sc0_int.h 
  * @author  
  * @version V1.1.0
  * @date    07-March-2022
  * @brief   This file contains the headers of the interrupt handlers.
  ******************************************************************************
  */ 

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SH3xf2xx_SC0_INT_H__
#define __SH3xf2xx_SC0_INT_H__

#ifdef __cplusplus
 extern "C" {
#endif 

/* Includes ------------------------------------------------------------------*/
#ifdef _RTE_
#include "RTE_Components.h"    
#include CMSIS_device_header
#endif

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

extern void NMI_Handler(void);
extern void HardFault_Handler(void);
extern void MemManage_Handler(void);
extern void BusFault_Handler(void);
extern void UsageFault_Handler(void);
extern void SVC_Handler(void);
extern void DebugMon_Handler(void);
extern void PendSV_Handler(void);
extern void SysTick_Handler(void);

extern void WWDT_Handler      (void); //   0 (040H) Window WatchDog Interrupt
extern void BOD_Handler       (void); //   1 (044H) Blownout Detection Interrupt
extern void RCC_Handler       (void); //   2 (048H) RCC global Interrupt
extern void EXTI0_Handler     (void); //   3 (04CH) EXTI Line0 Interrupt
extern void EXTI1_Handler     (void); //   4 (050H) EXTI Line1 Interrupt
extern void EXTI2_Handler     (void); //   5 (054H) EXTI Line2 Interrupt
extern void EXTI3_Handler     (void); //   6 (058H) EXTI Line3 Interrupt
extern void EXTI7_4_Handler   (void); //   7 (05CH) EXTI Line4~7 Interrupt
extern void DMA_CH0_Handler   (void); //   8 (060H) DMA Channe0 Interrupt
extern void DMA_CH1_Handler   (void); //   9 (064H) DMA Channe1 Interrupt
extern void DMA_CH2_Handler   (void); //  10 (068H) DMA Channe2 Interrupt
extern void DMA_CH3_Handler   (void); //  11 (06CH) DMA Channe3 Interrupt
extern void DMA_CH4_Handler   (void); //  12 (070H) DMA Channe4 Interrupt
extern void DMA_CH5_7_Handler (void); //  13 (074H) DMA Channe5~7 Interrupt
extern void MCM0_FLT_Handler  (void); //  14 (078H) MCM0 FAULT Interrupt
extern void MCM1_FLT_Handler  (void); //  15 (07CH) MCM1 FAULT Interrupt
extern void MCM0_PWM_Handler  (void); //  16 (080H) MCM0 PWM Interrupt
extern void MCM1_PWM_Handler  (void); //  17 (084H) MCM1 PWM Interrupt
extern void ADC0_Handler      (void); //  18 (088H) ADC0 Interrupt
extern void ADC1_Handler      (void); //  19 (08CH) ADC1 Interrupt
extern void ADC2_Handler      (void); //  20 (090H) ADC2 Interrupt
extern void PCA0_FLT_Handler  (void); //  21 (094H) PCA0 Fault Interrupt
extern void PCA1_FLT_Handler  (void); //  22 (098H) PCA1 Fault Interrupt
extern void PCA2_FLT_Handler  (void); //  23 (09CH) PCA2 Fault Interrupt
extern void PCA3_FLT_Handler  (void); //  24 (0A0H) PCA3 Fault Interrupt
extern void PCA0_Handler      (void); //  25 (0A4H) PCA0 Interrupt
extern void PCA1_Handler      (void); //  26 (0A8H) PCA1 Interrupt
extern void PCA2_Handler      (void); //  27 (0ACH) PCA2 Interrupt
extern void PCA3_Handler      (void); //  28 (0B0H) PCA3 Interrupt
extern void CMP0_Handler      (void); //  29 (0B4H) CMP0 Interrupt
extern void CMP1_Handler      (void); //  30 (0B8H) CMP1 Interrupt
extern void CMP2_Handler      (void); //  31 (0BCH) CMP2 Interrupt
extern void QEI_Handler       (void); //  32 (0C0H) QEI Interrupt
extern void CAN0_Handler      (void); //  33 (0C4H) CAN0 Interrupt
extern void TWI0_Handler      (void); //  34 (0C8H) TWI0 Interrupt
extern void SPI0_Handler      (void); //  35 (0CCH) SPI0 Interrupt
extern void SPI1_Handler      (void); //  36 (0D0H) SPI1 Interrupt
extern void UART0_Handler     (void); //  37 (0D4H) UART0 Interrupt
extern void UART1_Handler     (void); //  38 (0D8H) UART1 Interrupt
extern void UART2_Handler     (void); //  39 (0DCH) UART2 Interrupt
extern void UART3_Handler     (void); //  40 (0E0H) UART3 Interrupt
extern void TIM0_Handler      (void); //  41 (0E4H) TIM0 Interrupt
extern void TIM1_Handler      (void); //  42 (0E8H) TIM1 Interrupt
extern void EXTI15_8_Handler  (void); //  43 (0ECH) EXTI Line8 ~ Line15 Interrupt

#ifdef __cplusplus
}
#endif

#endif /* __SH3xf2xx_SC0_INT_H__ */

/************************ (C) COPYRIGHT Sinowealth *****END OF FILE****/
